/* 
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */


#include "TaskItem.h"
#include "cpp-utils/vector.h"

namespace mirai {

	void TaskItem::markAsDone() {
		state = DONE;
	}

	void TaskItem::markAsUndone() {
		state = TODO;
	}

	void TaskItem::setDate(const std::string& date) {
		this->date = date;
	}

	void TaskItem::setText(const std::string& text) {
		this->text = text;
	}

	const std::string& TaskItem::getText() const { return text; }
	const TaskItemState& TaskItem::getState() const { return state; }
	const std::string& TaskItem::getDate() const { return date; }
	const std::string& TaskItem::getStartTime() const { return startTime; }
	const std::string& TaskItem::getEndTime() const { return endTime; }
	const Tags& TaskItem::getTags() const { return tags; }
	bool TaskItem::hasDate() const { return isDate(date); }


	bool TaskItem::hasTag(const std::string& tag) const {
		return vectorUtils::contains(tags, tag);
	}
}
